/***************************************************************************
 * dhcp.c: RFC2131 implementation for ATmega88.
 * Copyright (C) 2007 Michael C McTernan,
 *    Michael.McTernan.2001@cs.bris.ac.uk
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ***************************************************************************/

#ifndef DHCP_H
#define DHCP_H

/**************************************************************************
 * Nested Include Files
 **************************************************************************/

#include <stdint.h>
#include "eth.h"
#include "udp.h"
#include "ip.h"

/**************************************************************************
 * Prototypes
 **************************************************************************/

boolean_t Dhcp(void);
void      DhcpStop(void);
void      DhcpProcessPacket(const ipparam_t  *ipp,
                            const udpparam_t *udpp);
void      DhcpRenew(void);
boolean_t DhcpRebind(void);

#endif /* DHCP_H */

/* END OF FILE */
